<?php
	// referer`FbN
	$pattern = '/^http:\/\/' . preg_quote($_SERVER["HTTP_HOST"]) . '/';
	if (!(preg_match($pattern, $_SERVER["HTTP_REFERER"])) ||
	    $_SERVER["REQUEST_METHOD"] != "POST")
	{
		header("HTTP/1.1 400 Bad Request");
		return;
	}

	// _vZ
	$score = getScore();

	// LO
	$rank = getRank($score);

	// json`ŕԋp
	print <<<RES
({
	'status': 'ok'
,	'score': $score
,	'rank': $rank
})
RES;

/* C܂ */

/// XRAvZ ///
function getScore(){
	// ݒ擾
	$rows = $_POST['rows'];	//̏c
	$cols = $_POST['cols'];	//̉
	$rabs = $_POST['rabs'];	//e̐
	$stns = $_POST['stns'];	//΂̐
	$rems = $_POST['rems'];	//c莞
	$time = $rows * $cols;	//ݒ莞ԁȉc~j

	// {[iX`FbN
	$flag = $_POST['flag'];	//Ă̐
	$hits = $_POST['hits'];	//ۂɐ΂݂̐
	$left = $_POST['left'];	//Ȃ̑̐

	// ԔŃ{[iX
	$t_bonus = ($time - $rems)==0 ? 0 : ($rabs + $stns) / ($time - $rems);

	// 󂫃ZŃ{[iX
	$c_bonus= $left / $time;

	// 󂫃ZcĂȂꍇ̓{[iX
	$l_bonus= ($left == 0) ? 0.5 : 0;

	// {ĂȂꍇ͐΃{[iX
	$f_bonus= ($flag == 0) ? 0.5 : 0;

	// ̐𗦂ɂĐ΃{[iX
	$h_bonus = $stns==0 ? 0 : $hits / $stns * 0.5;

	// ΁Feŕ␳
	$s_bonus = $rabs==0 ? 1 : $stns / $rabs;

	// ΓeFZŕ␳
	$r_bonus = $time==0 ? 1 : ($rabs + $stns) / $time;

	// ieW{ΌWj~␳
	return floor(($rabs * ($t_bonus + $c_bonus + $l_bonus) + $stns * ($f_bonus + $h_bonus)) * $s_bonus * $r_bonus * 1000);
}

/// LO ///
function getRank($score){
	// ̖ݒ̏ꍇ̓LOȂ
	if ($_POST['name'] == '') return 0;

	// 擾
	$mode = $_POST['mode'];

	switch ($mode) {
		case 0:
			//t[
			$file = 'free';
			break;
		case 1:
			//
			$file = 'low';
			break;
		case 2:
			//
			$file = 'mid';
			break;
		case 3:
			//㋉
			$file = 'high';
			break;
		default:
			return 0;
	}

	// bN擾
	$lock = 'score/' . $file . '.lock';
	while(@!mkdir($lock)){
		usleep(100000);
	}

	try {
		// nCXRA擾
		$rank = 0;
		$scoreFile = 'score/' . $file . '.txt';

		if (file_exists($scoreFile)){
			$contents = file_get_contents($scoreFile);
		}else{
			$contents = false;
		}

		if (! $contents) {
			$scoreLine = editScoreLine($score);
			file_put_contents($scoreFile, $scoreLine);
			$rank = 1;
		}else{
			$highScore = explode("\n", $contents);
			$last = count($highScore)>9 ? 10 : count($highScore);
			for ($i=0; $i<$last; $i++){
				$line = explode("\t", $highScore[$i]);
				if ($line[0] < $score) {
					$rank = $i + 1;
					break;
				}
			}

			if ($last < 10 && $rank == 0){
				$rank = $last + 1;
			}

			if ($rank != 0){
				$scoreLine = editScoreLine($score);
				array_splice($highScore,$rank-1,0,$scoreLine);
				if (count($highScore) > 10) {
					array_pop($highScore);
				}
				$contents = implode ("\n", $highScore);
				file_put_contents($scoreFile, $contents);
			}
		}
	} catch (Exception $e) {
	}

	// bN
	rmdir($lock);

	return $rank;
}


/// nCXRAsҏW ///
function editScoreLine($score) {
	$name = $_POST['name'];
	$line = array(
		$score
	,	$name
	,	$_POST['mode']
	,	$_POST['rows']
	,	$_POST['cols']
	,	$_POST['rabs']
	,	$_POST['stns']
	,	$_POST['rems']
	,	$_POST['flag']
	,	$_POST['hits']
	,	$_POST['left']
	);
	return implode("\t", $line);
}
